Subject: [dhcwg] RFC 4704 DHCPv6 FQDN Option 39

From: Govind Saoji <[email-masked]>
Date: Thu, 27 Mar 2008 11:48:41 +0530

Hi, I have query regarding how domain name is passed in FQDN option 39. According to RFC 4704 section 4.2,
The Domain Name part of the option carries all or part of the FQDN ofa DHCPv6 client.  The data in the Domain Name field MUST be encodedas described in Section 8 of [5]. 
According to RFC 3315 section 8,
Domain name or a list of domain names is encoded using the technique described insection 3.1 of RFC 1035 [10].  
According to RFC 1035, section 3.1
Domain names in messages are expressed in terms of a sequence of labels.Each label is represented as a one octet length field followed by thatnumber of octets.  Since every domain name ends with the null label ofthe root, a domain name is terminated by a length byte of zero.  Thehigh order two bits of every length octet must be zero, and theremaining six bits of the length field limit the label to 63 octets orless.
 
Looking at above format, from implementation perspective, this adds extra overhead on DHCPv6 client and DHCPv6 server even though they have nothing to do with those name...other than passing to DNS. It could have been much simpler if could have just passed Fully Qualified Domain Name in this option as was the case with DHCPv4 protocol where sending FQDN in this format is not MUST clause. It would be great if anyone can help in understanding reasoning behind this decision. Also, I am sceptical about DNS compatibility if we follow different formats in case of DHCPv4 and DHCPv6. Any thoughts? ThanksGS

Windows Live Spaces : Help your online world come to life, add 500 photos a month. Try it! 
_________________________________________________________________
Video: Get a glimpse of the latest in Cricket, Bollywood, News and Fashion. Only on MSN videos.
http://video.msn.com/?mkt=en-in

_______________________________________________
dhcwg mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/dhcwg

---

From: Ted Lemon <[email-masked]>
Date: Tue, 8 Apr 2008 10:29:18 -0700

On Mar 26, 2008, at 11:18 PM, Govind Saoji wrote:
> It would be great if anyone can help in understanding reasoning
> behind this decision. Also, I am sceptical about DNS compatibility
> if we follow different formats in case of DHCPv4 and DHCPv6. Any
> thoughts?

The spec is as written, so unless it's really badly broken, you're
stuck with it.   And I don't think it's broken at all, actually.

DNS wire format is the correct format for domain names encapsulated in
DHCP messages because there is no possibility of information loss.
Presentation format (a text string) is appropriate for displaying
domain names for humans to read.   However, the translation between
DNS presentation format and wire format is beyond the scope of the DHC
working group to specify, so it's really better for us to just specify
the wire format, which is documented in an RFC to which we can refer.

In practice, translating between wire-format and presentation format
is about 50 lines of code, so there's really no significant space or
time overhead.

Also, please bear in mind the line that you did *not* quote from  
RFC3315, which says that label compression is not permitted.   This  
substantially simplifies translating to DNS wire format; if you were  
to fail to notice this restriction, I could see where you might  
consider implementing the wire format conversion to be too much.